--- src/sysfs.cpp.orig	2006-06-29 21:16:10.000000000 +0200
+++ src/sysfs.cpp	2009-11-07 20:20:47.359588144 +0100
@@ -62,14 +62,21 @@
   while (i < deviceList.count())
   {
     if(QFile("/sys/block/" + deviceList[i] + "/queue/protect").exists())
-	i++;
+	  i++;
+	// newer kernels provide a different interface
+    else if (QFile("/sys/block/" + deviceList[i] + "/device/unload_heads").exists())
+      i++;
     else
-        deviceList.remove(deviceList.at(i));
+      deviceList.remove(deviceList.at(i));
   }
   return deviceList;
 }
 
 bool SysFS::queueProtected(QString device)
 {
-  return fileBool("/sys/block/" + device + "/queue/protect");
+  // newer kernels provide a different interface
+  if (QFile("/sys/block/" + device + "/device/unload_heads").exists())
+    return fileBool("/sys/block/" + device + "/device/unload_heads");
+  else
+    return fileBool("/sys/block/" + device + "/queue/protect");
 }
